class Camera
    attr_accessor :x, :y

    def initialize (args)
        @args = args
        @x ||= 0
        @y ||= 0
    end

    def update args
        @x = args.state.player.ship.x + (args.state.player.ship.w / 2) - (NOKIA_WIDTH / 2)
        @y = args.state.player.ship.y + (2) - (NOKIA_HEIGHT / 2)

        @x = 0 if @x < 0
        @x = MAP_WIDTH - NOKIA_WIDTH if @x > MAP_WIDTH - NOKIA_WIDTH
        @y = 0 if @y < 0
        @y = MAP_HEIGHT - NOKIA_HEIGHT if @y > MAP_HEIGHT - NOKIA_HEIGHT

        drawDebug(args) if DEBUG
    end

    def drawDebug args
        args.nokia.labels << {
            x: 2,
            y: NOKIA_HEIGHT - 2,
            size_enum: NOKIA_FONT_8BIT_SM,
            font: NOKIA_FONT_8BIT_PATH,
            text: "x: #{@x}"
        }

        args.nokia.labels << {
            x: 2,
            y: NOKIA_HEIGHT - 9,
            size_enum: NOKIA_FONT_8BIT_SM,
            font: NOKIA_FONT_8BIT_PATH,
            text: "y: #{@y}"
        }
    end
end