CHAT_WIDTH = 78
CHAT_LINE = 8

class Chat
    attr_accessor :msg, :name, :start_tick, :page, :opening, :space_width

    def showMessage (args, msg, name)
        @start_tick = args.tick_count
        @msg = msg
        @name = name
        @page = 0
        @opening = true

        @space_width = args.gtk.calcstringbox(" ", NOKIA_FONT_8BIT_SM, NOKIA_FONT_8BIT_PATH).x1

        args.state.gameState = GAME_STATE[:chat]
    end

    def update args
        @page += 1 if args.inputs.keyboard.key_down.enter || args.inputs.keyboard.key_down.x || args.inputs.keyboard.key_down.space
        args.state.gameState = GAME_STATE[:map] if args.inputs.keyboard.key_down.escape || @page >= @msg.length()
    end

    def draw args
        if (@opening)
            sprite_frame = start_tick.frame_index(5, 3, false)
            sprite_frame ||= 4
            
            args.nokia.sprites << {
                x: 0,
                y: 0,
                w: 84,
                h: 48,
                path: "sprites/scroll/scroll-#{sprite_frame}.png"
            }

            @opening = false if (sprite_frame == 4)
        else
            # Scroll
            args.nokia.sprites << {
                x: 0,
                y: 0,
                w: 84,
                h: 48,
                path: "sprites/scroll/scroll-4.png"
            }

            # Name
            name_w = args.gtk.calcstringbox(@name, NOKIA_FONT_8BIT_SM, NOKIA_FONT_8BIT_PATH).x1

            args.nokia.labels << {
                x: (NOKIA_WIDTH / 2) - (name_w / 2) + 2,
                y: NOKIA_HEIGHT - 5,
                text: @name,
                font: NOKIA_FONT_8BIT_PATH,
                size_enum: NOKIA_FONT_8BIT_SM
            }

            # Message
            lines = getLines(args, @msg[@page])
            count = 0
            
            lines.each do |l|
                args.nokia.labels << {
                    x: 6,
                    y: NOKIA_HEIGHT - 14 - (CHAT_LINE * count),
                    text: l,
                    font: NOKIA_FONT_8BIT_PATH,
                    size_enum: NOKIA_FONT_8BIT_SM
                }
                count += 1
            end

            # Continue
            more = @page < @msg.length - 1

            args.nokia.labels << {
                x: (NOKIA_WIDTH / 2) - (more ? 3: 1),
                y: 10,
                text: more ? "..." : ".",
                font: NOKIA_FONT_8BIT_PATH,
                size_enum: NOKIA_FONT_8BIT_SM
            }
            
        end
    end

    def getLines (args, text)
        tokens = text.split(" ")
        lines = []

        line = ""

        tokens.each do |t|
            if (args.gtk.calcstringbox(line + t, NOKIA_FONT_8BIT_SM, NOKIA_FONT_8BIT_PATH).x1 < CHAT_WIDTH)
                line += t + " "
            else
                lines[lines.length()] = line
                line = t + " "
            end
        end

        lines[lines.length()] = line

        return lines
    end
end