COMBAT_LEFT = 20
COMBAT_RIGHT = 60
COMBAT_Y = 19
COMBAT_VAR = 15
COMBAT_SHOOT = 5
COMBAT_HIT = 15

WINS = [
    ["HAHAHA take that suck0rz!"],
    ["Lol nice try"],
    ["Sucks to be you lol"],
    ["Thanks, that will pay for some gear"],
    ["I'm invincible!"],
    ["I'm indestructable!"],
    ["Awww looks like you lost"],
    ["Better luck next time lol"],
    ["You tried, you failed lol"],
    ["Hope you enjoy that L"],
    ["F"],
    ["Lolllll bye bye"],
    ["No one can beat me"],
    ["That's what you get son!"],
    ["Mess with da best, die like da rest"],
    ["Hot DAMN I'm unstoppable!"],
    ["N00b"],
    ["Thanks for the gold!"],
    ["That's gotta sting lol"],
    ["Oooooh that's gotta hurt! lol"],
    ["Well you tried lol"],
    ["ez"],
]

LOSSES = [
    ["Enjoy it while it lasts"],
    ["Just wait, I'll get you later"],
    ["Oh well, enjoy the gold"],
    ["Damn"],
    ["Ugh whatever"],
    ["Nooooo!"],
    ["Aw dang"],
    ["Well that sucks"],
    ["Crap, how'd you do that?"],
    ["Man I thought I had you"],
    ["You must've cheated!"],
    ["Oh come on!"],
    ["HOW????"],
    ["Time to log off I guess"],
    ["NOOO WHY??"],
    ["Aw man I saved up forever"],
    ["Meh I didn't really try anyway"],
    ["Shenanigans!"],
    ["Not cool, not cool"],
]

class Combat
    attr_accessor :enemy, :player,
                  :b1_x, :b2_x,
                  :p_shot, :e_shot,
                  :p_hit, :p_hit_time,
                  :e_hit, :e_hit_time,
                  :p_fire, :e_fire,
                  :bombing, :b_y

    def start (args, enemy)
        @enemy = enemy
        @b1_x = 100
        @b2_x = -50
        @player = args.state.player.ship

        @bombing = false

        @p_shot = 0
        @e_shot = 0
        @p_hit = 0
        @e_hit = 0
        @p_hit_time = 0
        @e_hit_time = 0

        @p_fire = ranFire(@player)
        @e_fire = ranFire(@enemy.ship)

        args.state.gameState = GAME_STATE[:combat]
    end

    def update args
        # Why do I need to redo this?
        @p_shot ||= 0
        @e_shot ||= 0
        @p_hit ||= 0
        @e_hit ||= 0
        @p_hit_time ||= 0
        @e_hit_time ||= 0
        @bombing ||= false

        # Birds
        @b1_x -= 0.1
        @b2_x += 0.075
        @b1_x = 100 if @b1_x < -50
        @b2_x = -50 if @b2_x > 90

        # Input
        if (args.inputs.keyboard.key_down.enter || args.inputs.keyboard.key_down.x || args.inputs.keyboard.key_down.space)
            if (@player.bombs > 0)
                @bombing = true
                @b_y = COMBAT_Y - 5
                @player.bombs -= 1
            end
        end

        # Bomb
        if (@bombing && args.tick_count % 6 == 0)
            @b_y += 1
            
            if (@b_y > COMBAT_Y)
                @bombing = false
                @enemy.ship.health -= 2
                @e_hit_time = COMBAT_HIT
            end
        end

        # Hit Animation
        if (@p_hit_time > 0)
             @p_hit = 1 - @p_hit if args.tick_count % 2 == 0
             @p_hit_time -= 1
        else
            @p_hit = 0
        end

        if (@e_hit_time > 0)
             @e_hit = 1 - @e_hit if args.tick_count % 2 == 0
             @e_hit_time -= 1
        else
            @e_hit = 0
        end

        # Shooting Animation
        if (@p_shot > 0)
            
            @p_shot -= 1
            
            if @p_shot <= 0
                @e_hit_time = COMBAT_HIT
                @enemy.ship.health -= 1
            end
        end

        if (@e_shot > 0)
            
            @e_shot -= 1
            
            if @e_shot <= 0
                @p_hit_time = COMBAT_HIT
                @player.health -= 1
            end
        end

        # Firing
        @p_fire -= 1
        @e_fire -= 1

        if (@p_fire <= 0)
            @p_shot = COMBAT_SHOOT
            @p_fire = ranFire(@player)
        end
        
        if (@e_fire <= 0)
            @e_shot = COMBAT_SHOOT
            @e_fire = ranFire(@enemy.ship)
        end

        # Win/Lose Condition
        if (@player.health < 0)
            args.state.gameState = GAME_STATE[:map]

            g = ((@player.gold / 2) + (@player.gold / 2) * rand).round
            g = @player.gold if g > @player.gold

            @player.gold -= g

            args.state.chat.showMessage(args, [WINS.sample[0], "Gold lost: #{g}"], @enemy.name)
        end

        if (@enemy.ship.health < 0)
            args.state.gameState = GAME_STATE[:map]
            args.state.chat.showMessage(args,  [LOSSES.sample[0], "Gold won: #{@enemy.ship.gold}"], @enemy.name)
            args.state.player.ship.gold += @enemy.ship.gold
            args.state.enemies -= [@enemy]
        end
    end

    def draw args
        @p_hit ||= 0
        @e_hit ||= 0

        # Birds
        args.nokia.solids << {
            x: @b1_x,
            y: NOKIA_HEIGHT - 3,
            w: 1,
            h: 1
        }

        args.nokia.solids << {
            x: @b2_x,
            y: NOKIA_HEIGHT - 4,
            w: 1,
            h: 1
        }

        # Background
        args.nokia.sprites << {
            x: 0,
            y: NOKIA_HEIGHT - 18,
            w: 84,
            h: 13,
            path: "sprites/mountains.png"
        }

        sprite_index = 0.frame_index(14, 12, true)

        args.nokia.sprites << {
            x: 0,
            y: 0,
            w: NOKIA_WIDTH,
            h: NOKIA_HEIGHT,
            path: "sprites/waves/combat_#{sprite_index}.png",
        }

        # Interface
        drawOption(args, 1, "bomb (#{@player.bombs})", @player.bombs > 0)

        # Player
        args.nokia.sprites << {
            x: COMBAT_LEFT - (@player.w / 2) - (@p_shot > 0 ? 1 : 0) - p_hit,
            y: COMBAT_Y,
            w: @player.w,
            h: @player.h,
            path: "sprites/ships/ship-#{@player.model}-0.png",
            flip_horizontally: false
        }

        px = COMBAT_LEFT - (@player.max_health / 2).floor - 2
        py = COMBAT_Y - 3
        args.nokia.lines << { x: px, y: py, x2: px + @player.health, y2: py}

        # Enemy
        args.nokia.sprites << {
            x: COMBAT_RIGHT - (@enemy.ship.w / 2) + (@e_shot > 0 ? 1 : 0) + e_hit,
            y: COMBAT_Y,
            w: @enemy.ship.w,
            h: @enemy.ship.h,
            path: "sprites/ships/ship-#{@enemy.ship.model}-0.png",
            flip_horizontally: true
        }
        
        ex = COMBAT_RIGHT + (@enemy.ship.max_health / 2).floor
        puts "ex- #{ex - @enemy.ship.health}"
        args.nokia.lines << { x: ex - @enemy.ship.health, y: py, x2: ex, y2: py}

        args.nokia.solids << {
            x: COMBAT_RIGHT,
            y: @b_y,
            w: 1,
            h: 1
        } if @bombing
    end

    def ranFire ship
        return (180 / ship.rate_of_fire) + (COMBAT_VAR * 2 * rand).floor - COMBAT_VAR
    end
end