ENEMY_RAN = 0.02
ENEMY_SPEED = 0.1
ENEMY_SPEED_VAR = 0.033
ENEMY_RADIUS = 5
ENEMY_PATH = [
    [94, 384 - 346],
    [126, 384 - 205],
    [64, 384 - 51],
    [163, 384 - 91],
    [300, 384 - 97],
    [343, 384 - 201],
    [303, 384 - 281],
    [183, 384 - 291],
]

USERS = ["2freeStunna", "Antonal", "BeCandy", "Champhi", "Dancent", "DariBlue", "DaysBorn2", "G0dz1ll4", "KittyUnique", "Leador", "LimeRyoth", "Loachid", "Majereno", "Martsh", "Michene", "Moffer", "Number1ft", "PrideSpuffy", "Prosta", "Quotele", "Sueller", "SynchroSara", "Testeam", "Tightvi", "Tureyrus", "Voodora", "Waterma", "Answell", "Bombsys", "Broodle", "Deepoi", "Diadrag", "DubyaChilled", "Dudesi", "EliteBobo", "Fantasticoa", "Fluently", "HeavenBorn", "Heraldz", "HorrayCake", "Kelpyle", "Licastal", "Mcre", "Moffer", "NayborRely", "Newalkli", "Nonspur", "Panchas", "Passqu", "Priment", "Relysi", "ReportCy", "Schonetc", "SellGlory", "Smostati", "ThereLife", "Wackyiv", "Kevinator", "Pierate", "2cool2Cotton", "Activertha", "Bintureco", "Bootypent", "Charite", "Communique", "Conseyra", "Direchaul", "Donaldanen", "Earthorat", "Fondleyal", "Freexingh", "GatoNan", "GravityJung", "LawSupreme", "LogMiny", "LolTalent", "Olympitism", "Proconde", "Rapanbra", "Securtimi", "Shoestion", "Softarch", "Squestes", "Stainuspo", "Styxia", "Abouter", "Acumetrak", "Alorso", "AnimePride", "Carylog", "Cleasa", "CoopSurreal", "Cozinen", "Davitst", "Diagonale", "DoubleRich", "Elstan", "Extellis", "Gigate", "Gyrover", "Hellock", "KroolGnome", "LightSaber", "Littleaf", "MarcsTopic", "Playanog", "Prominsus", "ReaderKool", "Reportall", "RosaWasabi", "Rustic", "Shugarla", "StasiaZin", "Thelizr", "Vandervi"]

class Enemy
    attr_accessor :name, :ship, :dir, :cur, :next, :speed

    def initialize args
        @args = args
        
        @name = USERS.sample
        @cur = (ENEMY_PATH.length() * rand).floor
        @dir = [true, false].sample
        @speed = ((ENEMY_SPEED_VAR * 2) * rand) - ENEMY_SPEED_VAR
        
        selection = ["sm", "sm", "sm", "md", "md", "lg"]
        selection = ["sm", "md", "md", "lg"] if args.state.player.ship.model == "md"
        selection = ["sm", "md", "md", "lg", "lg", "lg"] if args.state.player.ship.model == "lg"

        @ship = Ship.new(args, ENEMY_PATH[@cur][0], ENEMY_PATH[@cur][1], selection.sample)
        @next = @cur + (dir ? 1 : -1)
        @next = ENEMY_PATH.length() - 1 if @next < 0
        @next = 0 if @next >= ENEMY_PATH.length()
    end

    def update args
        c = getDirection()
        
        @ship.x += c.x * (ENEMY_SPEED + @speed)
        @ship.y += c.y * (ENEMY_SPEED + @speed)
        @ship.dir = c.x < 0

        if (getDistance([@ship.x, @ship.y], ENEMY_PATH[@next]) < ENEMY_RADIUS)
            @cur = @next
            @next += @dir ? 1 : -1

            @next = ENEMY_PATH.length() - 1 if @next < 0
            @next = 0 if @next >= ENEMY_PATH.length()
        end
    end

    def draw args
        @ship.draw(args)
    end

    def getDirection
        v = Vector2d.new(ENEMY_PATH[@next][0] - @ship.x, ENEMY_PATH[@next][1] - @ship.y)
        return v.normalize()
    end
end