TOWN = [280, 342, 40, 25]
DETECT_RADIUS = 15

class Player
    attr_accessor :ship, :dir, :closest

    def initialize (args, x, y)
        @args = args
        @ship ||= Ship.new(args, x, y, "sm", true)
        @ship.bombs = @ship.max_bombs
        @closest = nil
    end

    def update args
        xp = @ship.x
        yp = @ship.y

        @ship.x -= SHIP_SPEED * @ship.rate_of_fire if args.inputs.keyboard.left && checkCollision(args, -1, 0)
        @ship.x += SHIP_SPEED * @ship.rate_of_fire if args.inputs.keyboard.right && checkCollision(args, 1, 0)
        @ship.y += SHIP_SPEED * @ship.rate_of_fire if args.inputs.keyboard.up && checkCollision(args, 0, 1)
        @ship.y -= SHIP_SPEED * @ship.rate_of_fire if args.inputs.keyboard.down && checkCollision(args, 0, -1)

        @ship.dir = false if xp < @ship.x && @ship.dir
        @ship.dir = true if xp > @ship.x && !@ship.dir

        @dir = [Math.sqrt((xp - @ship.x) * (xp - @ship.x)), Math.sqrt((yp - @ship.y) * (yp - @ship.y))]

        args.state.menu.town.open(args) if ((args.inputs.keyboard.key_down.enter || args.inputs.keyboard.key_down.x || args.inputs.keyboard.key_down.space) && ([args.state.player.ship.x, args.state.player.ship.y].inside_rect? TOWN))
        args.state.menu.pause.open(args) if args.inputs.keyboard.key_down.escape
        args.state.menu.stats.open(args) if args.inputs.keyboard.key_down.i

        @closest = nil
        distance = DETECT_RADIUS * 2

        args.state.enemies.each do |e|
            d = getDistance([@ship.x + (@ship.w / 2), @ship.y], [e.ship.x + (e.ship.w / 2), e.ship.y])
            if d < DETECT_RADIUS
                if d < distance
                    distance = d
                    @closest = e
                end
            end
        end

        args.state.combat.start(args, @closest) if (args.inputs.keyboard.key_down.enter || args.inputs.keyboard.key_down.x || args.inputs.keyboard.key_down.space) && @closest
    end

    def draw args
        @ship.draw(args)
        drawOption(args, 1, "Fight", true) if @closest
    end

    def checkCollision (args, x, y)
        return true if !COLLISION_ENABLED

        dw = @ship.w
        dh = @ship.h
        dx = (@ship.x - 2).round
        dy = (@ship.y - 1).round
        
        for fy in 0..dh
            for fx in 0..(dw + 2)
                if (MAP_DATA[dy + fy + y][dx + fx + x] == 0)
                    return false 
                end
            end
        end

        return true
    end
end