SHIP_SPEED = 0.25

class Ship
    attr_accessor :x, :y, :w, :h, :dir, :model, :health, :max_health, :bombs, :max_bombs, :rate_of_fire, :gold

    def initialize (args, x, y, model, player = false)
        @args = args
        @model ||= model
        
        case @model
        when "sm"
            @max_health = @health = 5
            @max_bombs = @bombs = 2
            @rate_of_fire = 1
            @gold = 25 + (50 * rand).round
        when "md"
            @max_health = @health = 7
            @max_bombs = @bombs = 3
            @rate_of_fire = 3
            @gold = 50 + (100 * rand).round
        when "lg"
            @max_health = @health = 13
            @max_bombs = @bombs = 5
            @rate_of_fire = 5
            @gold = 150 + (300 * rand).round
        else
            puts "Unhandled ship model: #{@model}"
        end

        if player
            @rate_of_fire += 0.5
            @gold = 43
        end
        
        dim = args.gtk.calcspritebox("sprites/ships/ship-#{model}-0.png")
        @x ||= x
        @y ||= y
        @w ||= dim.x1
        @h ||= dim.y1
        @dir ||= false
    end

    def draw args
        sprite_frame = 0.frame_index(2, 24, true)

        args.nokia.sprites << {
            x: @x - args.state.camera.x,
            y: @y - args.state.camera.y,
            w: @w,
            h: @h,
            path: "sprites/ships/ship-#{@model}-#{sprite_frame}.png",
            flip_horizontally: @dir
        }
        
        drawDebug(args) if DEBUG
    end
    
    def drawDebug args
        args.nokia.labels << {
            x: 2,
            y: NOKIA_HEIGHT - 16,
            size_enum: NOKIA_FONT_8BIT_SM,
            font: NOKIA_FONT_8BIT_PATH,
            text: "x: #{@x}"
        }

        args.nokia.labels << {
            x: 2,
            y: NOKIA_HEIGHT - 23,
            size_enum: NOKIA_FONT_8BIT_SM,
            font: NOKIA_FONT_8BIT_PATH,
            text: "y: #{@y}"
        }
    end
end